import numpy
import matplotlib

a = numpy.matrix(numpy.zeros(25,float).reshape(5,5))
b = numpy.matrix(numpy.zeros(25,float).reshape(5,5))
c = numpy.matrix(numpy.zeros(18,float).reshape(3,6))
d = numpy.matrix(numpy.zeros(18,float).reshape(3,6))
m = 0.5

def train_neural(FinalX,FinalY,wh,wy,Eps):

    input_x = 4
    nh = 5
    output_y = 3
    A = 0 #valore di attivazione del neurone
    X = FinalX # lista di tutti gli input
    H = numpy.arange(5.)# sigmoide , uscita del nostro neurone
    Y = numpy.arange(3.) #  di tutti gli output
     
     #struttura dati aggiuntiva per apprendimento
    Eps = 0.2
    D = FinalY#dati output conosciuti
    DeltaY = numpy.arange(3.)#modifica errore sulle y
    DeltaH = numpy.arange(5.) #modifica errore sulla sigmoide
    Output_Matrix =numpy.matrix(numpy.arange(880*3.).reshape(880,3))
    for s in range( X.shape[0]):
        #implementazione dei pesi
        t = X[s,3]
        if t == 10:
            B = 0.05
        if t == 11:
            B = 0.1
        if t == 12:
            B = 0.15
        if t == 13 :
            B = 0.18
        if t == 14:
            B = 0.206
        if t == 15:
            B = 0.25
        if t == 16:
            B = 0.3
        if t == 17:
            B = 0.4
        if t == 18:
            B = 0.6
        if t == 19:
            B = 0.8
        if t == 20:
            B = 0.9  
            


        for k in range(nh ):

            A = 0
            for i in range(nh - 2):
                A = A + wh[k,i]*X[s,i]/100
            A = A + wh[k,nh - 2]*B
            A = A + wh[k,nh - 1]# qui sta sommando il treshold
            H[k] = 1/(1 + numpy.exp(-A))


        for j in range (output_y):

            A = 0
            for k in range(nh):
                A = A + wy[j,k]*H[k]
            A = A + wy[j,nh]
            Y[j] = 1/(1 + numpy.exp(-A))
            #print "Y[",j,"]=",Y[j] 
            Output_Matrix[s,j] = Y[j]

            #back propagation

            #calcolo errore strato output
        for j in range (output_y):
            Err =D[s,j]/100 - Y[j]
            DeltaY[j] = Err*Y[j]*(1 - Y[j])
            #print "Err = " , Err , "DeltaY = ", DeltaY[j]


        #calcolo errore strato H
        
        for k in range(nh):
            Err = 0
            for j in range(output_y):
                Err = Err + DeltaY[j]*wy[j,k]
            DeltaH[k] = Err*H[k]*(1 - H[k])
            #print "Err2 = " , Err , "DeltaH = ", DeltaH[k]

            #modifica pesi strato y

        for j in range(output_y):

            for k in range(nh):
                c[j,k] = wy[j,k]
                wy[j,k] = wy[j,k] + Eps*DeltaY[j]*H[k] + m*d[j,k]
                d[j,k] = c[j,k] - wy[j,k]
            c[j,nh] = wy[j,nh ]
            wy[j,nh] = wy[j,nh] + Eps*DeltaY[j] + m*d[j,k]
            d[j,nh] = c[j,nh] - wy[j,nh] 
        #for j in range(output_y):

         #   for k in range(nh):
          #      wy[j,k] = wy[j,k] + Eps*DeltaY[j]*H[k]
           # wy[j,nh] = wy[j,nh] + Eps*DeltaY[j]

            #modifica pesi strato H
        for k in range(input_x-1):
            for i in range(nh - 2):
                a[k,i] = wh[k,i]
                wh[k,i] = wh[k,i] + Eps*DeltaH[k]*X[s,i]/100 + m*b[k,i]
                b[k,i] = a[k,i] -wh[k,i] 
            a[k,nh-2] = wh[k,nh-2]
            wh[k,nh-2]=wh[k,nh-2] +Eps*DeltaH[k]*B + m*b[k,nh-2]
            a[k,nh-1] = wh[k,nh-1]
            wh[k,nh-1] = wh[k,nh-1] + Eps*DeltaH[k] + m*b[k,nh-1]
            b[k,nh-1] = a[k,nh-1] - wh[k,nh-1]
       # for k in range(nh - 1):
        #    for i in range(input_x - 2):
         #       wh[k,i] = wh[k,i] + Eps*DeltaH[k]*X[s,i]/100
          #  wh[k,input_x-1]=wh[k,input_x-1] +Eps*DeltaH[k]*B    
           # wh[k,input_x] = wh[k,input_x] + Eps*DeltaH[k]
    return Output_Matrix



def test_neural (FinalTestX,wh,wy):
     
    input_x = 4
    nh = 5
    output_y = 3
    A = 0 #valore di attivazione del neurone
    X = FinalTestX # lista di tutti gli input
    H = numpy.arange(5.)# sigmoide , uscita del nostro neurone
    Y = numpy.arange(3.) #  di tutti gli output
     
    Output_Matrix_T = numpy.matrix(numpy.arange(220*3.).reshape(220,3))
    for s in range( X.shape[0]):
        #implementazione dei pesi
        t = X[s,3]
        if t == 10:
            B = 0.05
        if t == 11:
            B = 0.1
        if t == 12:
            B = 0.15
        if t == 13 :
            B = 0.18
        if t == 14:
            B = 0.206
        if t == 15:
            B = 0.25
        if t == 16:
            B = 0.3
        if t == 17:
            B = 0.4
        if t == 18:
            B = 0.6
        if t == 19:
            B = 0.8
        if t == 20:
            B = 0.9  
            

        for k in range(nh ):

            A = 0
            for i in range(nh - 2):
                A = A + wh[k,i]*X[s,i]/100
            A = A + wh[k,nh - 2]*B
            A = A + wh[k,nh - 1]# qui sta sommando il treshold
            H[k] = 1/(1 + numpy.exp(-A))    
        

        for j in range (output_y):

            A = 0
            for k in range(nh):
                A = A + wy[j,k]*H[k]
            A = A + wy[j,nh]
            Y[j] = 1/(1 + numpy.exp(-A))
            #print "Y[",j,"]=",Y[j] 
            Output_Matrix_T[s,j] = Y[j]

    return Output_Matrix_T

def ErrTrain(FinalY,Output_matrix):
    ErrMaxs = FinalY/100 - Output_matrix
    M = 0.

    for i in range(ErrMaxs.shape[0]):
        for j in range(ErrMaxs.shape[1]):
            if abs(ErrMaxs[i,j]) > M:
                M = abs(ErrMaxs[i,j])

    return M

def ErrTest (FinalTestY,Output_Matrix_T):
    ErrMaxs = Output_Matrix_T - FinalTestY/100

    M = 0.

    for i in range(ErrMaxs.shape[0]):
        for j in range(ErrMaxs.shape[1]):
            if abs(ErrMaxs[i,j]) > M:
                M = abs(ErrMaxs[i,j])

    return M
